import sys
import matplotlib.pyplot as plt
from sklearn import model_selection
from sklearn.metrics import confusion_matrix

import numpy as np

def simulate_prostate_cancer_data():
    # simulate normal samples
    npoints = 30
    means=[70,70]
    #cov = [[90,40],[40,50]]
    cov = [[120,60],[60,50]]
    np.random.seed(3)
    
    normal1 = np.random.multivariate_normal(means,cov, npoints)
    labels_normal1 = np.zeros((npoints, 1))
    npoints = 30
    means=[140,60]
    #cov = [[90,40],[40,50]]
    cov = [[160,30],[30,50]]
    
    normal2 = np.random.multivariate_normal(means,cov, npoints)
    labels_normal2 = np.zeros((npoints, 1))
    
    npoints = 30
    means=[250,110]
    #cov = [[90,40],[40,50]]
    cov = [[300,30],[30,30]]
    
    normal3 = np.random.multivariate_normal(means,cov, npoints)
    labels_normal3 = np.zeros((npoints, 1))
    
    normal=np.concatenate((normal1,normal2,normal3))
    labels_normal=np.concatenate((labels_normal1,labels_normal2,labels_normal3))
    
    # simulate cancer samples
    npoints = 60
    means=[155,80]
    #cov = [[150,50],[50,50]]
    cov = [[4000,-600],[-600,50]]
    
    cancer1 = np.random.multivariate_normal(means,cov, npoints)
    labels_cancer1 = np.ones((npoints, 1))
    
    npoints = 40
    means=[50,80]
    #cov = [[150,50],[50,50]]
    cov = [[40,-60],[-60,50]]
    
    cancer2 = np.random.multivariate_normal(means,cov, npoints)
    labels_cancer2 = np.ones((npoints, 1))
    
    cancer=np.concatenate((cancer1,cancer2))
    labels_cancer=np.concatenate((labels_cancer1,labels_cancer2))
    
    X= np.concatenate((normal,cancer), axis=0)
    y = np.concatenate((labels_normal,labels_cancer), axis=0)
        
    return X, y


X,y = simulate_prostate_cancer_data()








