import sys
import matplotlib.pyplot as plt
from sklearn import model_selection
from sklearn.metrics import confusion_matrix


import numpy as np
npoints = 30
means=[70,70]
#cov = [[90,40],[40,50]]
cov = [[120,60],[60,50]]
np.random.seed(3)

normal1 = np.random.multivariate_normal(means,cov, npoints)
labels_normal1 = np.zeros((npoints, 1))
npoints = 30
means=[140,60]
#cov = [[90,40],[40,50]]
cov = [[160,30],[30,50]]

normal2 = np.random.multivariate_normal(means,cov, npoints)
labels_normal2 = np.zeros((npoints, 1))

npoints = 30
means=[250,110]
#cov = [[90,40],[40,50]]
cov = [[300,30],[30,30]]

normal3 = np.random.multivariate_normal(means,cov, npoints)
labels_normal3 = np.zeros((npoints, 1))


normal=np.concatenate((normal1,normal2,normal3))
labels_normal=np.concatenate((labels_normal1,labels_normal2,labels_normal3))


npoints = 60
means=[155,80]
#cov = [[150,50],[50,50]]
cov = [[4000,-600],[-600,50]]

cancer1 = np.random.multivariate_normal(means,cov, npoints)
labels_cancer1 = np.ones((npoints, 1))

npoints = 40
means=[50,80]
#cov = [[150,50],[50,50]]
cov = [[40,-60],[-60,50]]

cancer2 = np.random.multivariate_normal(means,cov, npoints)
labels_cancer2 = np.ones((npoints, 1))

cancer=np.concatenate((cancer1,cancer2))
labels_cancer=np.concatenate((labels_cancer1,labels_cancer2))


X= np.concatenate((normal,cancer), axis=0)
y = np.concatenate((labels_normal,labels_cancer), axis=0)



# split data into training and test datasets
X_train, X_test, y_train, y_test = \
    model_selection.train_test_split(X, y, test_size = 0.5, shuffle = True)

for i in range(len(X_train)):
    if y_train[i]>0:
        plt.plot(X_train[i,0],X_train[i,1],"or")
    else:
        plt.plot(X_train[i,0],X_train[i,1],"ob")

for i in range(len(X_test)):
    if y_test[i]>0:
        plt.plot(X_test[i,0],X_test[i,1],"xr")
    else:
        plt.plot(X_test[i,0],X_test[i,1],"xb")

plt.xlabel("CBC")
plt.ylabel("PSA")
plt.savefig("tree_train_test.png")

plt.clf()
for i in range(len(X_train)):
    if y_train[i]>0:
        plt.plot(X_train[i,0],X_train[i,1],"or")
    else:
        plt.plot(X_train[i,0],X_train[i,1],"ob")

plt.xlabel("CBC")
plt.ylabel("PSA")
plt.savefig("tree_train.png")



for depth in range(1,6):
    import graphviz 
    from sklearn import model_selection
    from sklearn.metrics import confusion_matrix
    from sklearn import model_selection,tree

    depth = 3
    clf = tree.DecisionTreeClassifier(max_depth=depth)
    clf.fit(X_train, y_train)
    p_train = clf.predict(X_train)
    p_test = clf.predict(X_test)

    #plot tree   
    dot_data = tree.export_graphviz(clf, out_file=None) 
    graph = graphviz.Source(dot_data) 
    graph.render("prostate_tree_depth_"+str(depth)) 
    
    # calculate training and testing error
    tn,fp,fn,tp = confusion_matrix(y_train,p_train).ravel()
    print("Training data:",tn,fp,fn,tp)
    tn,fp,fn,tp = confusion_matrix(y_test,p_test).ravel()
    print("Test data:",tn,fp,fn,tp)

    